<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Processors/TemplateLinker.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Processors/TemplateLinker.py</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Processors/TemplateLinker.py</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="py-comment"># Copyright (C) 2008 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno"> 7</span>
<a id="line8"></a><span class="lineno"> 8</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> *</span>
<a id="line9"></a><span class="lineno"> 9</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line10"></a><span class="lineno">10</span>
<a id="line11"></a><span class="lineno">11</span><span class="line"><span class="py-keyword">class</span> <a href="../../../Scopes/Synopsis/Processors/TemplateLinker/TemplateLinker.html">TemplateLinker</a>(Processor, ASG.Visitor):</span>
<a id="line12"></a><span class="lineno">12</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Link template specializations to their primary templates, and vice versa.&quot;&quot;&quot;</span></span>
<a id="line13"></a><span class="lineno">13</span>
<a id="line14"></a><span class="lineno">14</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/TemplateLinker/TemplateLinker.html#process">process</a>(self, ir, **kwds):</span>
<a id="line15"></a><span class="lineno">15</span>
<a id="line16"></a><span class="lineno">16</span><span class="line">        self.set_parameters(kwds)</span>
<a id="line17"></a><span class="lineno">17</span><span class="line">        self.ir = self.merge_input(ir)</span>
<a id="line18"></a><span class="lineno">18</span>
<a id="line19"></a><span class="lineno">19</span><span class="line">        <span class="py-keyword">for</span> d <span class="py-keyword">in</span> ir.asg.declarations:</span>
<a id="line20"></a><span class="lineno">20</span><span class="line">            d.accept(self)</span>
<a id="line21"></a><span class="lineno">21</span><span class="line">        <span class="py-keyword">return</span> self.output_and_return_ir()</span>
<a id="line22"></a><span class="lineno">22</span>
<a id="line23"></a><span class="lineno">23</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/TemplateLinker/TemplateLinker.html#link">link</a>(self, d):</span>
<a id="line24"></a><span class="lineno">24</span>
<a id="line25"></a><span class="lineno">25</span><span class="line">        <span class="py-keyword">if</span> d.is_template_specialization:</span>
<a id="line26"></a><span class="lineno">26</span><span class="line">            primary_name = d.name[:-1] + (d.name[-1].split(<span class="py-string">'&lt;'</span>)[0].strip(),)</span>
<a id="line27"></a><span class="lineno">27</span><span class="line">            primary = self.ir.asg.types.get(primary_name)</span>
<a id="line28"></a><span class="lineno">28</span><span class="line">            d.primary_template = primary_name</span>
<a id="line29"></a><span class="lineno">29</span><span class="line">            <span class="py-keyword">if</span> (type(primary) <span class="py-keyword">is</span> ASG.DeclaredTypeId <span class="py-keyword">and</span></span>
<a id="line30"></a><span class="lineno">30</span><span class="line">                d.name <span class="py-keyword">not</span> <span class="py-keyword">in</span> primary.declaration.specializations):</span>
<a id="line31"></a><span class="lineno">31</span><span class="line">                primary.declaration.specializations.append(d.name)</span>
<a id="line32"></a><span class="lineno">32</span>
<a id="line33"></a><span class="lineno">33</span><span class="line">    visit_forward = link</span>
<a id="line34"></a><span class="lineno">34</span><span class="line">    visit_class = link</span>
<a id="line35"></a><span class="lineno">35</span><span class="line">    visit_class_template = link</span>
<a id="line36"></a><span class="lineno">36</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:14 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
